
;.equ  DEBUG = DEBUG
;**** **** **** **** ****
;
;Die Benutzung der Software ist mit folgenden Bedingungen verbunden:
;
;1. Da ich alles kostenlos zur Verfgung stelle, gebe ich keinerlei Garantie
;   und bernehme auch keinerlei Haftung fr die Folgen der Benutzung.
;
;2. Die Software ist ausschlielich zur privaten Nutzung bestimmt. Ich
;   habe nicht geprft, ob bei gewerblicher Nutzung irgendwelche Patentrechte
;   verletzt werden oder sonstige rechtliche Einschrnkungen vorliegen.
;
;3. Jeder darf nderungen vornehmen, z.B. um die Funktion seinen Bedrfnissen
;   anzupassen oder zu erweitern. Ich wrde mich freuen, wenn ich weiterhin als
;   Co-Autor in den Unterlagen erscheine und mir ein Link zur entprechenden Seite
;   (falls vorhanden) mitgeteilt wird.
;
;4. Auch nach den nderungen sollen die Software weiterhin frei sein, d.h. kostenlos bleiben.
;
;!! Wer mit den Nutzungbedingungen nicht einverstanden ist, darf die Software nicht nutzen !!
;
; Juli 2004
; autor: Bernhard Konze
; email: bernhard.konze@versanet.de
; BRAKE added by KH Rhlow KarlHeinz.Ruehlow@oleco.net

;**** **** **** **** ****
; Device
;
;**** **** **** **** ****
.include "m8def.inc"
;**** **** **** **** ****
;**** **** **** **** ****
; fuses must be set to internal calibrated oscillator = 8 mhz
; check SUT1 CKSL3 CKSL1 CKSL0
;**** **** **** **** ****
;**** **** **** **** ****
.equ UART_CONTROL = 0
.equ UART_FULL	  = 0

.equ RC_PULS 	  = 1
; 1 -    PPM - 

.equ Current_OFF  = 1
; 0 -       

.equ MOT_BRAKE 	  = 0
; 1 -      -   N-, 
;   -         
;     2,6  ???

.equ Accucheck_OFF	= 0
; 0 -      
;     -     

.equ Accuinit_OFF	= 0
.equ Switch_off_activ =0 ; if 1 switch motor off at Min accu
.equ IGNORANTEN		= 0

.equ Beep_Zells		= 0; only vor test
; 0 - 2  - , 3  - 
; 1 - 2  - ,  -     


.equ Use_8_9Grad	=0
.equ Use_10_3Grad	=0
.equ Use_13_1Grad	=0
.equ Use_6_1Grad	=0
.equ Use_4_1GRAD	=0


; pin Behaviour
; =1 brcke gesteckt NC =0 brcke gesteckt LIPO
.equ FORCE_LIPO    = 0

.include "BB13.inc"

.equ	CHANGE_TIMEOUT	= 0x32
.equ	CHANGE_TOT_LOW	= 0x28
;.equ	CHANGE_TIMEOUT	= 0xa0
;.equ	CHANGE_TOT_LOW	= 0x90


;.equ	ST_CHANGE_TIMEOUT	= 0x48
;.equ	ST_CHANGE_TOT_LOW	= 0x42
;.equ	ST_CHANGE_TIMEOUT	= 0x60
;.equ	ST_CHANGE_TOT_LOW	= 0x50

.equ	ST_CHANGE_TIMEOUT	= 0x70
.equ	ST_CHANGE_TOT_LOW	= 0x30


.equ	POWER_RANGE	= 100			; full range of tcnt0 setting
.equ	MIN_DUTY	= 2			; no power
.equ	NO_POWER	= 256-MIN_DUTY		; (POWER_OFF)
.equ	MAX_POWER	= 256-POWER_RANGE	; (FULL_POWER)
.equ	MAX_POWER_RPM1	= POWER_RANGE/6
.equ	MAX_POWER_RPM2	= POWER_RANGE/2
.equ	START_RAMP	= 15

.equ	defaultTIMEOUT	= 32000
.equ	compScanTIMEOUT	= 48000

.equ	T1STOP	= 0x00
.equ	T1CK8	= 0x02

.equ	EXT0_DIS	= 0x00	; disable ext0int
.if RC_PULS == 1
.equ	EXT0_EN		= 0x40	; enable ext0int
.else
.equ	EXT0_EN		= 0x00	; disable ext0int
.endif

.equ	MIN_RC_PULS	= 1100			; s (or lower) = NO_POWER
.equ	MIN_RC_PULS_L	= 950
.equ	MID_RC_PULS	= 1600
.equ	MID_RC_PULS_L	= 1400


;**** **** **** **** ****
; Register Definitions
.def	i_sreg		 = r1	; status register save in interrupts
.def	tcnt0_power_on	 = r2	; timer0 counts nFETs are switched on
.def	tcnt0_change_tot = r3	; when zero, tcnt0_power_on is changed by one (inc or dec)
.def	TCNT1X	 	 = r4	; upper 8bit timer1 (software-) register
.def	uart_cnt	 = r5
.def	tcnt0_pwron_next = r6

.def	start_rcpuls_l	 = r7
.def	start_rcpuls_h	 = r8
.def	new_rcpuls_l	 = r9
.def	new_rcpuls_h	 = r10
.def	rcpuls_timeout	 = r11
.equ	RCP_TOT		 = 100

.def	current_err	 = r12	    ; counts consecutive current errors
.equ	CURRENT_ERR_MAX  = 5	; performs a reset after MAX errors

.def	sys_control	 = r13
.def	run_control	 = r14
;.def	Startup_count    = r15
.def    adc_loop_counter = r15 ;erstmal hier eingefgt
;gleiches register wiestartupcount

.def	temp1	= r16			; main temporary
.def	temp2	= r17			; main temporary
.def	temp3	= r18			; main temporary
.def	temp4	= r19			; main temporary

.def	i_temp1	= r20			; interrupt temporary
.def	i_temp2	= r21			; interrupt temporary
.def	i_temp3	= r22			; interrupt temporary

.def	flags0	= r23	; state flags
	.equ	OCT1_PENDING	= 0	; if set, output compare interrunpt is pending
	.equ	UB_LOW 		= 1	; set if accu voltage low
	.equ	I_pFET_HIGH	= 2	; set if over-current detect
	.equ	GET_STATE	= 3	; set if state is to be send
	.equ	C_FET		= 4	; if set, C-FET state is to be changed
	.equ	A_FET		= 5	; if set, A-FET state is to be changed
	     ; if neither 1 nor 2 is set, B-FET state is to be changed
	.equ	I_OFF_CYCLE	= 6	; if set, current off cycle is active
	.equ	EVAL_UB		= 7	; if set, next PWM on should look for power

.def	flags1	= r24	; state flags
	.equ	POWER_OFF	= 0	; switch fets on disabled
	.equ	FULL_POWER	= 1	; 100% on - don't switch off, but do OFF_CYCLE working
	.equ	CALC_NEXT_OCT1	= 2	; calculate OCT1 offset, when wait_OCT1_before_switch is called
	.equ	RC_PULS_UPDATED	= 3	; new rc-puls value available
	.equ	EVAL_RC_PULS	= 4	; if set, new rc puls is evaluated, while waiting for OCT1
	.equ	EVAL_SYS_STATE	= 5	; if set, overcurrent and undervoltage are checked
	.equ	EVAL_I		= 6	; if set, next PWM on should look for current
	.equ	T1OVFL_FLAG	= 7	; each timer1 overflow sets this flag - used for voltage + current watch

.def	flags2	= r25	; state flags		
	.equ	BRAKE_DONE	= 0	;
	.equ	POFF_CYCLE	= 1	; if set one commutation cycle is performed without power
	.equ    STARTUP		= 2
	.equ	LITHIUM_ACCU = 3 ; if set we ha a lithium accu conected
	.equ    DISABLE_FLAG = 4 ; if the inputvoltage isnt hig enough dont start the controller
	.equ  REVERSE_FLAG = 5

;**************** ACCU Voltages *****************
	.equ accu_measuring_loops = 0x05
	.equ zero                 = 0x00
	.equ first_time           = 0x01

;68K / 12K  divider 5/1024 = 4.88e-3 --> 27.67 mV pdigit
;neuer Spannungsteiler weil messung hin und wieder falsch zuviele Zellen
; regler schaltet dann herunter  sofort nach start
;12K/2k2 divider 5/1024 = 4.88e-3 --> 26.63 mV pdigit
; falls fr den Spannungsteiler am adc eingang KEINE 1% Widerstnde
; eingebaut wurden MUSS der
;Spannungsteiler mit Gutem Ohmmeter gemesen und  GENAU Eintragen werden
	.equ Mess_R_lo = 12.2
 	.equ Mess_R_hi  = 68
 	.equ Mess_Multi = (Mess_R_lo*204800)/(Mess_R_lo+Mess_R_hi)
	;.equ Mess_Multi = ((12.2)*204800)/((12.2)+(68))

 	;.equ min_accu                  =  55*Mess_Multi/10000  ; minimal voltage =5,5V
 	;.equ slow_accu                 =  60*Mess_Multi/10000  ; minimal voltage =6V
	.equ min_accu                  =  50*Mess_Multi/10000  ; minimal voltage =5,0V
 	.equ slow_accu                 =  55*Mess_Multi/10000  ; minimal voltage =5,5V
 	
 	.equ max_accu                  = 170*Mess_Multi/10000  ; maximal voltage =17V  @ 12 cells


 ; the value has to be changed if the voltage-divider is changed
 ; max cnt minvoltage of One Li zell
 	.equ max_voltage_of_one_LIcell  =  42.5*Mess_Multi/10000  ; 4.2V
 	.equ cnt_voltage_of_one_LIcell  =  37*Mess_Multi/10000  ; 3.7V
 	.equ min_voltage_of_one_LIcell  =  27*Mess_Multi/10000  ; 3.0V

; max cnt minvoltage of One NC zell
 	.equ max_voltage_of_one_NCcell  =  14*Mess_Multi/10000  ; 1.4V
 	.equ cnt_voltage_of_one_NCcell  =  14*Mess_Multi/10000  ; 1.4V
 	.equ min_voltage_of_one_NCcell  =   8*Mess_Multi/10000  ; 0.8V

 	.equ slow_voltage_of_one_LIcell =  29*Mess_Multi/10000 ; 2.9V
 	.equ slow_voltage_of_one_NCcell =   9*Mess_Multi/10000 ; 0.9V

	.equ OFF_voltage_of_one_LIcell  =  25*Mess_Multi/10000 ; 2.7V
 	.equ OFF_voltage_of_one_NCcell  =   6*Mess_Multi/10000 ; 0.7V

;**************** Current Voltages *****************
     ;0.01 OHM  -->  1 A -> 0.01 V
	 ;0.01 OHM  --> 10 A -> 0.10 V
	 ;0.01 OHM  --> 20 A -> 0.20 V
	 ;0.01 OHM  --> 40 A -> 0.40 V
	 ;0.01 OHM  --> 20 A -> 0.20 V/(5/1024)--> 41 --> 29h
	 ;0.01 OHM  --> 40 A -> 0.40 V/(5/1024)--> 82 --> 52h

	;.equ overcurrent_div= 5/1024*1000
	;.equ overcurrent_20 = 20*0.01 / 0.0048828
	;.equ overcurrent_40 = 40*0.01 / 0.0048828
	
	.equ overcurrent_20 = 0x29;h
	.equ overcurrent_40 = 0x52;h

; here the XYZ registers are placed ( r26-r31)

; ZH = new_duty		; PWM destination


;**** **** **** **** ****
; RAM Definitions
.equ	RAM_START = 0x0060
.dseg					;RAM segment
.org RAM_START

tcnt1_sav_l:	.byte	1	; actual timer1 value
tcnt1_sav_h:	.byte	1
tcnt1_sav_x:	.byte	1
last_tcnt1_l:	.byte	1	; last timer1 value
last_tcnt1_h:	.byte	1
last_tcnt1_x:	.byte	1

wt_comp_scan_l:	.byte	1	; time from switch to comparator scan
wt_comp_scan_h:	.byte	1
wt_FET_sw_l:	.byte	1	; motor timing
wt_FET_sw_h:	.byte	1

act_Accu_Voltage_h	:	.byte	1
act_Accu_Voltage_l	:	.byte	1
slow_down_voltage_l	:	.byte	1
slow_down_voltage_h	:	.byte	1
switch_off_voltage_h	:	.byte	1
switch_off_voltage_l	:	.byte	1
accu_cells		:	.byte	1
ComparatorMUX		:	.byte	1

OCT1_high:	.byte	1

uart_data:	.byte	100		; only for debug requirements
reverse_count		:	.byte	1
last_dir		:	.byte	1
.equ	STOP = 0x00
.equ	FWD = 0x01
.equ	REV = 0x02


;**** **** **** **** ****
; ATmega8 interrupts

;.equ	INT0addr=$001	; External Interrupt0 Vector Address
;.equ	INT1addr=$002	; External Interrupt1 Vector Address
;.equ	OC2addr =$003	; Output Compare2 Interrupt Vector Address
;.equ	OVF2addr=$004	; Overflow2 Interrupt Vector Address
;.equ	ICP1addr=$005	; Input Capture1 Interrupt Vector Address
;.equ	OC1Aaddr=$006	; Output Compare1A Interrupt Vector Address
;.equ	OC1Baddr=$007	; Output Compare1B Interrupt Vector Address
;.equ	OVF1addr=$008	; Overflow1 Interrupt Vector Address
;.equ	OVF0addr=$009	; Overflow0 Interrupt Vector Address
;.equ	SPIaddr =$00a	; SPI Interrupt Vector Address
;.equ	URXCaddr=$00b	; USART Receive Complete Interrupt Vector Address
;.equ	UDREaddr=$00c	; USART Data Register Empty Interrupt Vector Address
;.equ	UTXCaddr=$00d	; USART Transmit Complete Interrupt Vector Address
;.equ	ADCCaddr=$00e	; ADC Interrupt Vector Address
;.equ	ERDYaddr=$00f	; EEPROM Interrupt Vector Address
;.equ	ACIaddr =$010	; Analog Comparator Interrupt Vector Address
;.equ	TWIaddr =$011	; Irq. vector address for Two-Wire Interface
;.equ	SPMaddr =$012	; SPM complete Interrupt Vector Address
;.equ	SPMRaddr =$012	; SPM complete Interrupt Vector Address
;-----bko-----------------------------------------------------------------

;**** **** **** **** ****
.cseg
.org 0
;**** **** **** **** ****

;-----bko-----------------------------------------------------------------
; reset and interrupt jump table
		rjmp	reset
.if RC_PULS == 1
		rjmp	ext_int0
.else
		nop	; int0
.endif
		nop	; ext_int1
		nop	; t2oc_int
		nop	; t2ovfl_int
		nop	; icp1
		rjmp	t1oca_int
		nop	; t1ocb_int
		rjmp	t1ovfl_int
		rjmp	t0ovfl_int
		nop	; spi_int
		nop	; urxc
		nop	; udre
.if UART_CONTROL == 1
  .if UART_FULL == 1
		rjmp	utxc
  .else
		nop	; utxc
  .endif
.else
		nop	; utxc
.endif
; not used	nop	; adc_int
; not used	nop	; eep_int
; not used	nop	; aci_int
; not used	nop	; wire2_int
; not used	nop	; spmc_int


version:	.db	"BB13FLOH 306"

;-----bko-----------------------------------------------------------------
; init after reset

; init after reset

reset:
		ldi	temp1, high(RAMEND)	; stack = RAMEND
		out	SPH, temp1
		ldi	temp1, low(RAMEND)
		out 	SPL, temp1

	; portB - all FETs off
		ldi	temp1, INIT_PB		; PORTB initially holds 0x00
		out	PORTB, temp1
		ldi	temp1, DIR_PB
		out	DDRB, temp1

	; portC reads comparator inputs
		ldi	temp1, INIT_PC
		out	PORTC, temp1
		ldi	temp1, DIR_PC
		out	DDRC, temp1

	; portD reads rc-puls + AIN0 ( + RxD, TxD for debug )
		ldi	temp1, INIT_PD
		out	PORTD, temp1
		ldi	temp1, DIR_PD
		out	DDRD, temp1

	
	; timer0: PWM + beep control = 0x02 	; start timer0 with CK/8 (1s/count)
		ldi	temp1, 0x02
		out	TCCR0, temp1

	; timer1: commutation control = 0x02	; start timer1 with CK/8 (1s/count)
		ldi	temp1, T1CK8
		out	TCCR1B, temp1

	; reset state flags
		clr	flags0
		clr	flags1
		clr	flags2
		
		ldi	temp1, 0
		sts	reverse_count, temp1
		sts	last_dir, temp1

.if IGNORANTEN== 1
		sbr		flags2,1<<STARTUP
.endif
		clr		adc_loop_counter	;Startup_count

	; power off
		rcall	switch_power_off

	; reset rc puls timeout
		ldi	temp1, RCP_TOT
		mov	rcpuls_timeout, temp1
		
.if UART_CONTROL == 1

		ldi	ZH,high(version*2)
		ldi	ZL,low(version*2)

	;**** UART Initialization ****
		ldi	temp1, 12
		out	UBRR, temp1	; set to 38400baud (8MHz)
		ldi	temp1, 0x18
		out	UCR, temp1	; enable rx+tx - no interrupts !
		in 	temp1, UDR	; clear possibly pending rxc

		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; b
		rcall	send_byte
.endif

.ifndef DEBUG
		rcall	wait260ms	; wait a while
		rcall	wait260ms
.endif

.if UART_CONTROL == 1
		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; k
		rcall	send_byte
.endif

.if Accuinit_OFF == 0
		rcall   INIT_ACCU_CHECK
.endif
		sbi		Accu_Port,LOWACCU

.ifndef DEBUG
		rcall	beep328ms	; signal ready
.endif

NO_START:
		sbrc	flags2,DISABLE_FLAG
		rjmp 	NO_START

.ifdef DEBUG
		sbr		flags0,1<<EVAL_UB	
		rcall   ACCU_CHECK 		;only for test
		sbr		flags0,1<<EVAL_I	
		rcall   CURRENT_CHECK   ;only for test
.endif



.if UART_CONTROL == 1
		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; o
		rcall	send_byte
		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; (1st number)
		rcall	send_byte
.endif

control_start:	; init variables
		ldi	temp1, CHANGE_TIMEOUT
		sbrc	flags2,STARTUP
		ldi	temp1, ST_CHANGE_TIMEOUT
		mov	tcnt0_change_tot, temp1
		ldi	temp1, NO_POWER
		mov	tcnt0_power_on, temp1

		ldi	temp1, 0		; reset error counters
		mov	current_err,temp1
		mov	sys_control, temp1

	; init registers and interrupts
		ldi	temp1, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0)
		out	TIFR, temp1		; clear TOIE1,OCIE1A & TOIE0
		out	TIMSK, temp1		; enable TOIE1,OCIE1A & TOIE0 interrupts

.if UART_CONTROL == 1
		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; (2nd number)
		rcall	send_byte
.endif

		sei				; enable all interrupts

.if RC_PULS == 1
; init rc-puls
		ldi	temp1, (1<<ISC01)+(1<<ISC00)
		out	MCUCR, temp1		; set next int0 to rising edge
		ldi	temp1, EXT0_EN		; enable ext0int
		out	GIMSK, temp1
i_rc_puls1:	ldi	temp3, 10		; wait for this count of receiving power off
i_rc_puls2:	sbrs	flags1, RC_PULS_UPDATED
		rjmp	i_rc_puls2
		mov	temp1, new_rcpuls_l
		mov	temp2, new_rcpuls_h
		cbr	flags1, (1<<RC_PULS_UPDATED) ; rc impuls value is read out
		subi	temp1, low  (MID_RC_PULS)	; power off received ?
		sbci	temp2, high (MID_RC_PULS)
		brcc	i_rc_puls1		; no - reset counter
		dec		temp3			; yes - decrement counter
		brne	i_rc_puls2		; repeat until zero
		cli				; disable all interrupts

.if Beep_Zells==0
		rcall	beep328ms		; signal: rcpuls ready
		rcall	beep328ms
		Cbi		Accu_Port,LOWACCU

		sbrc	flags2,LITHIUM_ACCU
		rcall	beep328ms
.else
		sbrc    flags2,LITHIUM_ACCU
		rjmp    LIaccuBeep
		rcall	beep328ms		; no accucount with NC accu
		rcall	beep328ms
		rjmp    Beep_end

LIaccuBeep:
		lds     adc_loop_counter,accu_cells
beepzells:
		rcall	beep328ms
		dec		adc_loop_counter
		brne	beepzells
Beep_end:
		
.endif		
		sei				; enable all interrupts
.endif

;hier wre auch die richtige stelle fr ein rc setup
; z.b. umschalten von  lipo/nc
; rcpuls 5 sec vollgas dann umschalten
; NC   2 beep
; lipo 3 beep

.if UART_CONTROL == 1
		lpm
		adiw	ZL,1		;increment Z-pointer
		mov	temp1, r0	; (3rd number)
		rcall	send_byte
.endif

		ldi	ZH, MIN_DUTY-1		; ZH is new_duty from now
		cbr	flags0, (1<<A_FET)	; set to state1 condition
		sbr	flags0, (1<<C_FET)
		rcall	calculate_next_timing_values
		rcall	set_default_timeout
		rcall	wait_OCT1_tot		; init first timeout

	;wenn der ad converter an ist
	; ist kein comparator betrieb mglich...
	; ACME Analog Comparator Multiplexer Enable
	; ACME (SFIOR) muss 0 sein  ADEN muss 0 sein
	; SFIOR Special Function IO Register
		cbi 	ADCSRA,ADEN
		in		temp1, SFIOR
		sbr		temp1, (1<<ACME)
		out		SFIOR, temp1
		sbrc	flags2, REVERSE_FLAG
		ldi		temp1, mux_a		; set comparator multiplexer to phase A
		sbrs	flags2, REVERSE_FLAG
		ldi		temp1, mux_b		; set comparator multiplexer to phase A
		out		ADMUX, temp1

		rjmp	state1
		
.if RC_PULS == 1
;-------------------------------------------------------------------------
; external interrupt0 = rc pulse input
ext_int0:	in	i_sreg, SREG
		clr	i_temp1			; disable extint edge may be changed
		out	GIMSK, i_temp1

; evaluate edge of this interrupt
		in	i_temp1, MCUCR
		sbrs	i_temp1, ISC00
		rjmp	falling_edge		; bit is clear = falling edge

; should be rising edge - test rc impuls level state for possible jitter
		sbis	PIND, rcp_in
		rjmp	extint1_exit		; jump, if low state

; rc impuls is at high state
		ldi	i_temp1, (1<<ISC01)
		out	MCUCR, i_temp1		; set next int0 to falling edge

; get timer1 values
		in	i_temp1, TCNT1L
		in	i_temp2, TCNT1H
		mov	start_rcpuls_l, i_temp1
		mov	start_rcpuls_h, i_temp2

		rjmp	extint1_exit

; rc impuls is at low state
falling_edge:	sbic	PIND, rcp_in		; test level of rc impuls
		rjmp	extint1_exit		; seems to be a spike

		ldi	i_temp1, (1<<ISC01)+(1<<ISC00)
		out	MCUCR, i_temp1		; set next int0 to rising edge
		sbrc	flags1, RC_PULS_UPDATED
		rjmp	extint1_exit

; get timer1 values
		in	i_temp1, TCNT1L
		in	i_temp2, TCNT1H
		sub	i_temp1, start_rcpuls_l
		sbc	i_temp2, start_rcpuls_h

	; save impuls length
		mov	new_rcpuls_l, i_temp1
		mov	new_rcpuls_h, i_temp2
		cpi	i_temp1, low (2200)
		ldi	i_temp3, high(2200)	; test range high
		cpc	i_temp2, i_temp3
		brsh	extint1_exit		; through away
		cpi	i_temp1, low (800)
		ldi	i_temp3, high(800)	; test range low
		cpc	i_temp2, i_temp3
		brlo	extint1_exit		; through away
		sbr	flags1, (1<<RC_PULS_UPDATED) ; set to rc impuls value is ok !
		ldi	i_temp1, RCP_TOT
		mov	rcpuls_timeout, i_temp1

; enable int1 again -  also entry for spike detect
extint1_exit:	ldi	i_temp2, EXT0_EN
		out	GIMSK, i_temp2
		out	SREG, i_sreg
		reti
.endif
;-----bko-----------------------------------------------------------------
; output compare timer1 interrupt
t1oca_int:	in	i_sreg, SREG
		cbr	flags0, (1<<OCT1_PENDING) ; signal OCT1 passed
		out	SREG, i_sreg
		reti
;-----bko-----------------------------------------------------------------
; overflow timer1 / happens all 65536s
t1ovfl_int:	in	i_sreg, SREG
		inc	TCNT1X			; make a 24-bit counter
		sbr	flags1, (1<<T1OVFL_FLAG)

.if RC_PULS == 1
		tst	rcpuls_timeout
		breq	t1ovfl_99
		dec	rcpuls_timeout
.endif

t1ovfl_99:	out	SREG, i_sreg
		reti
;-----bko-----------------------------------------------------------------
; timer0 overflow interrupt
t0ovfl_int:	in	i_sreg, SREG
		sbrc	flags0, I_OFF_CYCLE
		rjmp	t0_on_cycle

t0_off_cycle:
	; changes in PWM ?
		mov	i_temp1, tcnt0_power_on
		mov	i_temp2, tcnt0_pwron_next
		cp	i_temp2, i_temp1
		brsh	lower_pwm		; next power-on-time is lower or same
higher_pwm:	dec	tcnt0_change_tot	; change-timeout passed ?
		brne	nFET_off		; .. no
		ldi	i_temp2, CHANGE_TIMEOUT	; .. yes - change-timeout for more power
		sbrc	flags2,STARTUP
		ldi	temp1, ST_CHANGE_TIMEOUT
		mov	tcnt0_change_tot, i_temp2 ; reset change-timeout and decrement
		dec	i_temp1			; <dec> increases power-on-time
		rjmp	set_next_pwm

lower_pwm:	breq	nFET_off		; pwm is unchanged
		dec	tcnt0_change_tot	; change-timeout passed ?
		brne	nFET_off		; .. no
		ldi	i_temp2, CHANGE_TOT_LOW ; .. yes - change-timeout for lower power
		sbrc	flags2,STARTUP
		ldi	i_temp2, ST_CHANGE_TOT_LOW ; .. yes - change-timeout for lower power
		mov	tcnt0_change_tot, i_temp2 ; reset change-timeout and increment
		inc	i_temp1			; <inc> decreases power-on-time

set_next_pwm:	mov	tcnt0_power_on, i_temp1

nFET_off:	sbr	flags0, (1<<I_OFF_CYCLE) ; PWM state = off cycle

	; switch appropriate nFET off
		sbrs	flags0, C_FET
		rjmp	test_AnFET

; C_FET is active
switch_CnFET:	
		sbrs	flags1, FULL_POWER
		cbi	CnFET_PORT, CnFET		; Cn off
		rjmp	reload_t0_off_cycle

test_AnFET:	sbrs	flags0, A_FET
		rjmp	switch_BnFET

; A_FET is active
switch_AnFET:	sbrc	flags1, FULL_POWER
		rjmp	reload_t0_off_cycle
		sbrc	flags2, REVERSE_FLAG
		cbi	AnFET_PORT, AnFET		; An off
		sbrs	flags2, REVERSE_FLAG
		cbi	BnFET_PORT, BnFET		; An off
switch_AnFET1:
		rjmp	reload_t0_off_cycle

; B_FET is active
switch_BnFET:	sbrc	flags1, FULL_POWER
		rjmp	reload_t0_off_cycle
		sbrc	flags2, REVERSE_FLAG
		cbi	BnFET_PORT, BnFET		; Bn off
		sbrs	flags2, REVERSE_FLAG
		cbi	AnFET_PORT, AnFET		; An off

	; reload timer0 with the appropriate value
reload_t0_off_cycle:
		mov	i_temp1, tcnt0_power_on
		subi	i_temp1, -POWER_RANGE	; adi i_temp1, POWER_RANGE
		com	i_temp1			; timer0 increments
		out	TCNT0, i_temp1

		rjmp	t0_int_exit

; reload timer90 + switch appropriate nFET on
t0_on_cycle:	mov	i_temp1, tcnt0_power_on
		out	TCNT0, i_temp1		; reload t0
		cbr	flags0, (1<<I_OFF_CYCLE) ; PWM state = on cycle (no off cycle)

; switch appropriate nFET on
nFET_on:	sbrs	flags0, C_FET		; is Cn choppered ?
		rjmp	test_AnFET_on			; .. no - test An
		sbrs	flags1, POWER_OFF
		sbi		CnFET_PORT, CnFET		; Cn on
		rjmp	eval_power_state
test_AnFET_on:	sbrs	flags0, A_FET		; is An choppered ?
		rjmp	sw_BnFET_on			; .. no - Bn has to be choppered
		sbrc	flags1, POWER_OFF
		rjmp	eval_power_state
		sbrc flags2, REVERSE_FLAG
		sbi		AnFET_PORT, AnFET		; An on
		sbrs flags2, REVERSE_FLAG
		sbi		BnFET_PORT, BnFET		; An on
		rjmp	eval_power_state
sw_BnFET_on:	sbrc	flags1, POWER_OFF
		rjmp	eval_power_state
		sbrc flags2, REVERSE_FLAG
		sbi		BnFET_PORT, BnFET		; Bn on
		sbrs flags2, REVERSE_FLAG
		sbi		AnFET_PORT, AnFET		; Bn on

	; evaluate power state
eval_power_state:
		cpi	i_temp1, MAX_POWER+1
		brsh	not_full_power
	; FULL POWER
		sbr	flags1, (1<<FULL_POWER)	; tcnt0_power_on = MAX_POWER means FULL_POWER
		cbr	flags1, (1<<POWER_OFF)
		
		rjmp	eval_ApFET_voltage
not_full_power:	cpi	i_temp1, NO_POWER
		brlo	neither_full_nor_off
	; POWER OFF
		cbr	flags1, (1<<FULL_POWER)	; tcnt0_power_on = NO_POWER means power off
		sbr	flags1, (1<<POWER_OFF)	;hier brake enable
		
		rjmp	eval_ApFET_voltage
neither_full_nor_off:
		cbr	flags1, (1<<FULL_POWER)	; tcnt0_power_on = MAX_POWER means FULL_POWER
		cbr	flags1, (1<<POWER_OFF)
		
eval_ApFET_voltage:
		;wir haben einen ad wandler also ndern
		sbrs	flags1, EVAL_I	; evaluation request ?
		;rjmp	t0_int_exit
		;sbis	BnFET_PORT, BnFET		; also Bn on ?
		rjmp	t0_int_exit
	; Cp + Bn active - look for overcurrent
		;change this we have an ad converter
		;sbis	ACSR, ACO		; if ACO=1 current is ok
		;sbr	flags0, (1<<I_pFET_HIGH)
		cbr	flags1, (1<<EVAL_I)

t0_int_exit:	
		sbrc	flags2, POFF_CYCLE
		sbr		flags1, (1<<POWER_OFF)
		out		SREG, i_sreg
		reti

;*********************************************************************
;* Funktion: INIT_ACCU_CHECK    									 *
; change this to 2 byte calculation
; move the results to the ram
;*********************************************************************
;* Description: Initialisation of accu-check                         *
;*********************************************************************
;
;      ^ U_accu
;      |
;      -
;     | | R1 = 100K	120K
;      -
;      |
;      o-----------o
;      |
;      -            U_adc
;     | | R2 = 5K6	6K8
;      -           o
;      |           |
;     ---         ---
;
; The controller is configured for 10-Bit resolution, but we use only the 8 LSB as we do not
; need to measure over the hole voltage range. I used a voltage divider with high resistance
; as we get high voltage peaks from the commutation of the motor.
; With this values it possible to measure up to 93 volts. But a well charged 12 cells accu
; has only a voltage of 15 volts sometimes more. With the 8 LSB of the ADC we can measure 23
; volts. The accuracy is 0.1(0.09) volts per digit. So we have enough protection for the ADC and we
; can measure up to 12 cells with enough accuracy.
;
;
;                            R2         1024                      1
; ADC_digits = U_accu * ------------ * ------   =   U_accu * 10.9 -
;                        R1  +   R2      5V                       V
; 120K / 12K  2.56 Reference value uaccu* 36.36 use right shiftet result ?????
; use 120K/6.8K and 5 Vref
;                          1
; U_accu_max = 1024 / 10.9 - = 93V  the maximum measurable voltage
;                          V
;
; 1 digit ~ 0.1V
;
;                              1
; U_accu_max@8bit = 256 / 10.9 - = 23V the maximum measurable voltage at LSB 8 bit
;                              V
;

INIT_ACCU_CHECK:
	cli			; int disable
	clr 		temp1
	
	; was frn Accu ham wer den angeschlossen
	; ist der pin auf Ground haben wir einen LiAccu angeschlossen

.if FORCE_LIPO    == 1 ; brcke gesteckt NC
	SBR		FLAGS2,1<<LITHIUM_ACCU
	sbi 	LI_Port,LI_PIN ; activate Pull UP
	nop
	sbic 	LI_Port_IN,LI_PIN
	SBR		FLAGS2,1<<LITHIUM_ACCU
	; was frn Accu ham wer den angeschlossen
	sbis 	LI_Port_IN,LI_PIN
	CBR		FLAGS2,1<<LITHIUM_ACCU
	cbi 	LI_Port,LI_PIN	; disable Pull UP

.else ; brcke gesteckt LIPO
	CBR		FLAGS2,1<<LITHIUM_ACCU

	sbi 	LI_Port,LI_PIN ; activate Pull UP
	nop
	sbis 	LI_Port_IN,LI_PIN
	SBR		FLAGS2,1<<LITHIUM_ACCU
	; was frn Accu ham wer den angeschlossen
	sbic 	LI_Port_IN,LI_PIN
	CBR		FLAGS2,1<<LITHIUM_ACCU
	cbi 	LI_Port,LI_PIN	; disable Pull UP

.endif
	
	
	; ACME (SFIOR) muss 0 sein to activate ADC multiplexer
	; SFIOR Special Function IO Register
	in		temp1, SFIOR
	cbr		temp1, (1<<ACME)
	out		SFIOR, temp1

	; VCC  is used as voltage reference,
	; ADC6 is used as voltage input
	; the adc result is right adjusted
	; hier den richtigen  "pfad" angeben INC file)
	ldi		temp1, ACCU_MUX	; set comparator multiplexer to ACCU Voltage Input
	out		ADMUX, temp1
	
	; The ADC is enabled and the prescaler 1/128 is selected.
	; In this case the ADC needs about 1 to 2 ms to measure the voltage(attiny).
    ;***************************************************************
	; das hier muss  kontrolliert werden  comparator adc umschaltung
	;***************************************************************
	clr 	temp1
	;No interrupts started at the moment
	; so we can use i_tempX without Problems
	ldi		i_temp1,first_time
	ldi     i_temp2,accu_measuring_loops
	sbr 	temp1,(1<<ADPS2) + (1<<ADPS1) + (1<<ADPS0)
	out 	ADCSRA,temp1
	sbi 	ADCSRA,ADEN

.ifndef DEBUG
	rcall	wait260ms
	rcall	wait260ms
.endif
	clr 	adc_loop_counter	; temp_reg3 is the ADC_LOOP_COUNTER
	sbi 	ADCSRA,ADSC			; start the conversion
	;this is only to ramp up ADconverter results
	;mesurements are to Low at startup
	; I dont like to lower The AD converter input resistor Values
ADC_Dummy:
	sbic 	ADCSRA,ADSC
	rjmp 	ADC_Dummy ; we wait until the conversion has finished
	in	 	temp1,ADCL ; we read the ADC-value both ADC regs MUST be read
	in 		temp2,ADCH ; we have also to read ADCH to get the measured value
	sbi 	ADCSRA,ADSC			; start the conversion
	inc		adc_loop_counter
	ldi		temp2,accu_measuring_loops
	cp	 	adc_loop_counter,temp2 ;compare to accu_measuring_loops
	brne	ADC_Dummy

	
CLEAR_ADC_LOOP_COUNTER:
	clr 	adc_loop_counter	; temp_reg3 is the ADC_LOOP_COUNTER
ADC_START:
	sbi 	ADCSRA,ADSC			; start the conversion
ADC_IS_STARTED_1:
	sbic 	ADCSRA,ADSC
	rjmp 	ADC_IS_STARTED_1 ; we wait until the conversion has finished
	in	 	temp1,ADCL ; we read the ADC-value both ADC regs MUST be read
	in 		temp2,ADCH ; we have also to read ADCH to get the measured value
.IFDEF DEBUG
	;68K / 12K  32.0V Vin(~22 zellen)->>  4.8V at ADC in
	;           10.2V Vin (7 zellen Voll)
	;10.2V Ubatt --> 1,53V ADC IN 1,53/(5/1024) 313 digits 139hex
	;10.2V Ubatt --> 7 zellen 6.3V slowdown 5.6V switch off
	;10.5V Ubat --> 1,575 adc in 1,575/(5/1024) 322,56 142h
	;12.4V Ubat --> 1,860 adc in 1,860/(5/1024) 380,92 17Ch
	;12.7V Ubat --> 1,905 adc in 1,905/(5/1024) 390,14 186h
	; 9.43V    --> 1,442 adc  in  295 127h
	; 8.80V    --> 1,32  adc  in  270 10eh
	; 8.30V    --> 1,32  adc  in  270 10eh
	; 5,50V Ubat --> 0.825 adc in 169 A8h
	sbr 	flags2,1<<Lithium_Accu
	;cbr 	flags2,1<<Lithium_Accu

	ldi temp1,0x0e ;low  8,8V ok
	ldi temp2,0x01 ;high

 	ldi temp1,0x27 ;low  9.43V ok
	ldi temp2,0x01 ;high

	;ldi temp1,0x39 ;low  10.2V
	;ldi temp2,0x01 ;high

 	ldi temp1,0x7c ;low  12.4V
	ldi temp2,0x01 ;high
	
	;ldi temp1,0x86 ;low  12.7V
	;ldi temp2,0x01 ;high
	
	;ldi temp1,0xa8 ;low 5.5V
	;ldi temp2,0x00 ;high
	;ldi temp1,0x68 ;120/6.8K only for debugging = 104 0.547 V ad 10.2V bat -->7 zellen 6.3V slowdown 5.6V switch off
.ENDIF


	tst	 	adc_loop_counter		 ;  compare with firsttime if we measure the first time...
	brne 	ADC_MEASURING_LOOP
once_again:
	clr		adc_loop_counter
	inc		adc_loop_counter
	STS 	act_Accu_Voltage_h,temp2 ; then we save it in the accu_voltage-variable
	STS 	act_Accu_Voltage_l,temp1 ; then we save it in the accu_voltage-variable
	rjmp 	ADC_START
	

ADC_MEASURING_LOOP:

    LDS 	temp4,act_Accu_Voltage_h ;
	LDS 	temp3,act_Accu_Voltage_l ;
	sub     temp3,temp1
	sbc     temp4,temp2
	brcs    once_again


	clr     i_temp1
	clr     i_temp2
    LDS 	temp4,act_Accu_Voltage_h ;
	LDS 	temp3,act_Accu_Voltage_l ;
	
	;add current Value to Stored Value
	add     temp1,temp3
	adc     temp2,temp4
	adc     i_temp1,i_temp2
	; divide value by two
	lsr		i_temp1
	ror	    temp2		
	ror     temp1

	STS 	act_Accu_Voltage_h,temp2 ; then we save it in the accu_voltage-variable
	STS 	act_Accu_Voltage_l,temp1 ; then we save it in the accu_voltage-variable
	inc		adc_loop_counter

	ldi		temp2,accu_measuring_loops
	cp	 	adc_loop_counter,temp2 ;compare to accu_measuring_loops
	brne 	ADC_START 		; we have to restart the measuring

	clr 	adc_loop_counter
	cbi 	ADCSRA,ADEN 			; reset the prescaler
	clr 	temp1
	sbr 	temp1,(1<<ADPS2) + (1<<ADPS1) + (1<<ADPS0) ; the prescaler 1/128 is selected
	out 	ADCSRA,temp1
	clr 	temp1
	sbr 	temp1,(1<<REFS0)+ACCU_MUX
	out 	ADMUX,temp1


	
	lds 	temp1,act_accu_voltage_l
	lds 	temp2,act_accu_voltage_h
	clr		adc_loop_counter

	sbrc 	flags2,Lithium_Accu
	rjmp 	Li_Zell
	
	ldi 	temp3,low(Cnt_voltage_of_one_NCcell)
	ldi 	temp4,high(Cnt_voltage_of_one_NCcell)

	rjmp CALCULATE_THE_NUMBER_OF_ACCUS
Li_Zell:
	ldi 	temp3,low(Cnt_voltage_of_one_LIcell)
	ldi 	temp4,high(Cnt_voltage_of_one_LIcell)

CALCULATE_THE_NUMBER_OF_ACCUS :
	inc 	adc_loop_counter
	; we substract the voltage of one cell from the measured voltage
    ; until the value gets negative, to calculate the number of cells
    ; in the plugged accu
	sub 	temp1,temp3 ; low  byte
	sbc 	temp2,temp4 ; high byte
	brcc  CALCULATE_THE_NUMBER_OF_ACCUS ;By Sven
	
	; the accu-counter must be decremented once, as it counted one accu
    ; too much, when the counter became smaller then zero
    dec 	adc_loop_counter
	
	;***************************************************************
	; recheck the  numer of counted Accu Cells By Sven Stcker
	; accu cell counter correction
	;***************************************************************
	sbrc 	flags2,Lithium_Accu
	rjmp 	Li_Zell_a
	
	ldi  	temp2,high(Max_voltage_of_one_NCcell)
  	ldi  	temp1,low (Max_voltage_of_one_NCcell)
	rjmp	RE_Calculate

Li_Zell_a:
	ldi  	temp2,high(Max_voltage_of_one_LIcell)
  	ldi  	temp1,low (Max_voltage_of_one_LIcell)

RE_Calculate:
	clr  	temp3
	clr  	temp4

  	mov  	i_Temp1,adc_loop_counter ; Move counted accus to loopcounter
CTNOA1:
	add		temp3,temp1
  	adc		temp4,temp2
  	dec  	i_Temp1
  	brne	CTNOA1
	
	; sub act voltage from MIN Voltage
	; measured 10V calculated 12.6
	; falls  min voltage - act voltage < 0 haben wir einen accu zuwenig
CTNOA2:
	lds		temp1,act_accu_voltage_l
  	lds 	temp2,act_accu_voltage_h
  	sub		temp3,temp1
  	sbc		temp4,temp2
	brcc	CTNOA3
  	inc		adc_loop_counter ; correct accucounter dy one cell
CTNOA3:
	sts		accu_cells,adc_loop_counter
	;mov     i_temp3,adc_loop_counter ;
;*****************************************************************
	sbrc 	flags2,Lithium_Accu
	rjmp 	min_Li_Voltage
	ldi 	temp2,high(slow_voltage_of_one_NCcell)
	ldi 	temp1,low(slow_voltage_of_one_NCcell)
	;switch off voltage sollte noch etwas kleiner sein als min voltage
	ldi 	i_temp2,high(OFF_Voltage_of_one_NCcell)
	ldi 	i_temp1,low(OFF_voltage_of_one_NCcell)
	
	rjmp 	CALCULATE_THE_MIN_VOLTAGE

min_Li_Voltage:
	ldi 	temp2,high(slow_voltage_of_one_LIcell)
	ldi 	temp1,low(slow_voltage_of_one_LIcell)
	;switch off voltage sollte noch etwas kleiner sein als min voltage
	ldi 	i_temp2,high(OFF_voltage_of_one_LIcell)
	ldi 	i_temp1,low(OFF_voltage_of_one_LIcell)

CALCULATE_THE_MIN_VOLTAGE:
	CLR		temp3
	CLR		temp4
CALCULATE_MIN_VOLTAGE:
	add 	temp3,temp1 ; the slow. voltage of a cell is added as often as we have cells
	adc 	temp4,temp2 ; the slow. voltage of a cell is added as often as we have cells
	dec 	adc_loop_counter	;TST adc_loop_counter
	brne 	CALCULATE_MIN_VOLTAGE

	sts 	slow_down_voltage_l,temp3 ;save to ram
	sts 	slow_down_voltage_h,temp4 ;save to ram
	
CALCULATE_THE_SWITCHOFF_VOLTAGE:
	CLR		temp3
	CLR		temp4
	lds     adc_loop_counter,accu_cells ; restore counted accus
CALCULATE_SWITCHOFF_VOLTAGE:
	add 	temp3,i_temp1 ; the switchoff voltage of a cell is added as often as we have cells
	adc 	temp4,i_temp2 ; the switchoff voltage of a cell is added as often as we have cells
	dec 	adc_loop_counter	;TST adc_loop_counter
	brne 	CALCULATE_SWITCHOFF_VOLTAGE

	sts 	switch_off_voltage_l,temp3 ;save to ram
	sts 	switch_off_voltage_h,temp4 ;save to ram

	; if the calculated voltage is lower than min_accu, then we
	; load min_accu into switch_off_voltage
	;     Slow Accu into slow_down_voltage
	ldi 	temp1,low(Slow_accu)  ; min
	ldi 	temp2,high(Slow_accu) ; min

	lds 	temp3,slow_down_voltage_l
	lds 	temp4,slow_down_voltage_h
	
	;two byte compare necessary
	cp temp4,temp2  ;Compare switch_off_voltage high byte
	; falls das ergebniss hher ausfllt allses ok
	; ist es gleich  auch egal
	brsh END_OF_MEASURING

	;cp temp3,temp2  ;Compare switch_off_voltage low  byte
   	;brsh END_OF_MEASURING

	;store min_accu to slow_down_voltage
	sts slow_down_voltage_l,temp1
	sts slow_down_voltage_h,temp2

END_OF_MEASURING:

	clr 	temp1
	;sbr 	temp1,(1<<ADPS0) ; the prescaler 1/2 4MHz is selected
	;sbr 	temp1,(1<<ADPS1) ; the prescaler 1/4 2MHzis selected
	;sbr 	temp1,(1<<ADPS1) + (1<<ADPS0) ; the prescaler 1/8 1MHz is selected
	sbr 	temp1,(1<<ADPS2)  ; the prescaler 1/16 600KHz is selected
	;noch Schneller ist nicht gut
	;sbr 	temp1,(1<<ADPS2) + (1<<ADPS0) ; the prescaler 1/32 ~200Khz is selected
	out 	ADCSRA,temp1
	
	cbi 	ADCSRA,ADEN 			
	clr 	adc_loop_counter

	;wenn der ad converter an ist
	; ist kein comparator betrieb mglich...
	; ACME Analog Comparator Multiplexer Enable
	; ACME (SFIOR) muss 0 sein  ADEN muss 0 sein
	; SFIOR Special Function IO Register
	in		temp1, SFIOR
	sbr		temp1, (1<<ACME)
	out		SFIOR, temp1

	ldi 	temp3,low(min_accu) ;switch_off_voltage_l
	ldi 	temp4,high(min_accu);switch_off_voltage_h

	sbrc 	flags2,Lithium_Accu
	rjmp    nc_accu
	lds 	temp3,switch_off_voltage_l
	lds 	temp4,switch_off_voltage_h

nc_accu:
	lds 	temp1,act_accu_voltage_l
	lds 	temp2,act_accu_voltage_h
		
    sub		temp1,temp3
	sbc 	temp2,temp4
	brcs    SET_NO_Start
    ret
SET_NO_Start:
	sbr		flags2,DISABLE_FLAG
	ret

;-----bko-----------------------------------------------------------------
; beeper: timer0 is set to 8s/count - 2072s period (about 500hz beep)
beep328ms:	;sbi	DDRD, redLED		; LED red on

	; 128 pulses = 265ms beep
		ldi	temp2, 128
beep_ApBn:	clr	temp1
		out	TCNT0, temp1
		sbi	ApFET_PORT, ApFET		; ApFET on
		sbi	BnFET_PORT, BnFET		; BnFET on
beep_ApBn10:	in	temp1, TCNT0
		cpi	temp1, 32		; 32s on
		brne	beep_ApBn10
		cbi	ApFET_PORT, ApFET		; ApFET off
		cbi	BnFET_PORT, BnFET		; BnFET off
		ldi	temp3, 8		; 2040s off
beep_ApBn12:	clr	temp1
		out	TCNT0, temp1
beep_ApBn13:	in	temp1, TCNT0
		cpi	temp1, 255
		brne	beep_ApBn13
		dec	temp3
		brne	beep_ApBn12
		dec	temp2
		brne	beep_ApBn

	; 128 periods = 261ms silence
wait260ms:	ldi	temp2, 128
beep_ApBn20:	ldi	temp3, 8
beep_ApBn21:	clr	temp1
		out	TCNT0, temp1
beep_ApBn22:	in	temp1, TCNT0
		cpi	temp1, 255
		brne	beep_ApBn22
		dec	temp3
		brne	beep_ApBn21
		dec	temp2
		brne	beep_ApBn20

		ret
;-----bko-----------------------------------------------------------------
tcnt1_to_temp:	ldi	temp4, EXT0_DIS		; disable ext0int
		out	GIMSK, temp4
		ldi	temp4, T1STOP		; stop timer1
		out	TCCR1B, temp4
		ldi	temp4, T1CK8		; preload temp with restart timer1
		in	temp1, TCNT1L		;  - the preload cycle is needed to complete stop operation
		in	temp2, TCNT1H
		mov	temp3, TCNT1X
		out	TCCR1B, temp4
		ret				; !!! ext0int stays disabled - must be enabled again by caller
	; there seems to be only one TEMP register in the AVR
	; if the ext0int interrupt falls between readad LOW value while HIGH value is captured in TEMP and
	; read HIGH value, TEMP register is changed in ext0int routine
;-----bko-----------------------------------------------------------------
calculate_next_timing_values:
		rcall	tcnt1_to_temp
		ldi	temp4, EXT0_EN		; ext0int enable
		out	GIMSK, temp4		; enable ext0int
		sts	tcnt1_sav_l, temp1
		sts	tcnt1_sav_h, temp2
		sts	tcnt1_sav_x, temp3
		lds	YL, last_tcnt1_l
		lds	YH, last_tcnt1_h
		lds	ZL, last_tcnt1_x
		sub	temp1, YL
		sbc	temp2, YH
		sbc	temp3, ZL
		
; now temp-registers hold the time of 360 - means: 6 commutations

; each commutation is divided in two stages:
; a) wait for expected zero-crossing
; b) wait less than 30 and commutate

; divide by 12 would result in 0 timing ( 30 )
; ***   earlier zero-crossing as it is expected, cannot be detected
; ***   switch to next commutation not less than 30 - means: stall

; divide by 16 would result in 7.5 degree timing ( 30.0-22.5 ), works !
; ***   start to look for zero-crossing 7.5 earlier than it is expected
; ***   switch to next commutation 7.5 earlier than 30
; 7.5 value can be changed when setting <wt_FET_switch>

		ldi	temp4, 4		; divide by 16
calc_OCT1_d16:	lsr	temp3
		ror	temp2
		ror	temp1
		dec	temp4
		brne	calc_OCT1_d16

		mov	YL, temp1
		mov	YH, temp2
		mov	ZL, temp3

; ZL should be zero - if not, use max value
		tst	temp3
		brne	calc_OCT1_res
		sts	OCT1_high, temp2
		tst	temp2
		breq	calc_OCT1_of10
		clr	run_control
		subi	temp1, low (defaultTIMEOUT)
		sbci	temp2, high(defaultTIMEOUT)
		brcc	calc_OCT1_res
		rjmp	calc_OCT1_of80
calc_OCT1_of10:	tst	run_control
		brne	calc_OCT1_of11
		ldi	temp2, 0xff
		mov	run_control, temp2
calc_OCT1_of11:	mov	temp2, tcnt0_power_on
		asr	temp2
		asr	temp2		; (e7-ff)
		subi	temp2, 0xca	; 9c->1b and ff->33
		
; the maximum of allowed RPM is dependent from PWM
; therefore 134000 RPM (refered to 6 commutations each) is reached now
;temp2	rpm (6 Kom.)	rpm Achse
;0x1b	138888		23148		; full power
;0x33	 73529		12254		; lowest power

		cp	temp1, temp2
		brcc	calc_OCT1_of80
		mov	YL, temp2	; limit RPM
		rjmp	calc_OCT1_of80
calc_OCT1_res:	rcall	set_default_timeout
		rjmp	calc_OCT1_of90
calc_OCT1_of80:
		sts	wt_comp_scan_l, YL	; capture compare offset for time from switch to comparator scanning
		sts	wt_comp_scan_h, YH

	; if an other timing than 7.5 is wanted, change YL,YH here
; example (13.1):
.if Use_13_1Grad==1
		sbrc flags2,STARTUP
        rjmp end13_1GRAD
		lsr	YH
		ror	YL
		mov	temp1,YL 		; 1/32 + 1/64 = 1/21.33 (30-16.9=13.1)
		mov	temp2,YH
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
end13_1GRAD:
.endif

; example (10.3):
.if Use_10_3Grad==1
		sbrc flags2,STARTUP
        rjmp end10_3GRAD
		lsr	YH
		ror	YL
		mov	temp1,YL 		; 1/32 + 1/64 + 1/128 = 1/18.3 (30-19.7=10.3)
		mov	temp2,YH
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
 end10_3GRAD:
.endif

; example (8.9):
.if Use_8_9Grad==1

 		sbrc flags2,STARTUP
        rjmp end8_9GRAD
		lsr	YH
		ror	YL
		mov	temp1,YL 		; 1/32 + 1/64 + 1/128 + 1/256 = 1/17.1 (30-21.1=8.9)
		mov	temp2,YH
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
		lsr	temp2
		ror	temp1
		add	YL, temp1
		adc	YH, temp2
 end8_9GRAD:
.endif

; example (7.5):
; do nothing


; example (6.1):
.if Use_6_1Grad==1
		mov	temp1,YL 		; 1/16 + 1/256 = 1/15.06 (30-23.9=6.1)
		mov	temp2,YH
		ldi	temp4, 4		; divide by 16
calc_OCT1_dt61:	lsr	temp2
		ror	temp1
		dec	temp4
		brne	calc_OCT1_dt61
		add	YL, temp1
		adc	YH, temp2
.endif

; example (4.7):
.if USE_4_1GRAD==1
		sbrc flags2,STARTUP
        rjmp end4_1GRAD
		mov	temp1,YL 		; 1/16 + 1/128 = 1/14.22 (30-25.3=4.7)
		mov	temp2,YH
		ldi	temp4, 3		; divide by 8
calc_OCT1_dt41:	lsr	temp2
		ror	temp1
		dec	temp4
		brne	calc_OCT1_dt41
		add	YL, temp1
		adc	YH, temp2
end4_1GRAD:
.endif
		sts	wt_FET_sw_l, YL	; capture compare offset for time from zero-crossing to switch
		sts	wt_FET_sw_h, YH
calc_OCT1_of90:	lds	temp1, tcnt1_sav_l
		lds	temp2, tcnt1_sav_h
		lds	temp3, tcnt1_sav_x
		sts	last_tcnt1_l, temp1
		sts	last_tcnt1_h, temp2
		sts	last_tcnt1_x, temp3
		ret
;-----bko-----------------------------------------------------------------
.if RC_PULS == 1
update_power_control:
		sbrs	flags1, RC_PULS_UPDATED
		rjmp	upd_duty90
		rcall	evaluate_rc_puls
		rcall	set_new_duty
upd_duty90:	ret

evaluate_rc_puls:
		sbrs	flags1, RC_PULS_UPDATED
		rjmp	eval_rc_p90
		mov	temp1, new_rcpuls_l
		mov	temp2, new_rcpuls_h
		cbr	flags1, (1<<RC_PULS_UPDATED) ; rc impuls value is read out
		subi	temp1, low  (MID_RC_PULS)
		sbci	temp2, high (MID_RC_PULS)
	   ldi	temp4, fwd
		brcc	eval_rc_p00	; if >MIN_RC_PULS then goto
		mov	temp1, new_rcpuls_l
		mov	temp2, new_rcpuls_h
		subi	temp1, low  (MIN_RC_PULS_L)
		sbci	temp2, high (MIN_RC_PULS_L)
		ldi	temp4, rev
		brcc	eval_rc_p001	; if >MIN_RC_PULS then goto
		clr	temp1       ; else =0
		clr	temp2
		rjmp	eval_rc_p00
eval_rc_p001:
		mov	temp1, new_rcpuls_l
		mov	temp2, new_rcpuls_h
		subi	temp1, low  (MID_RC_PULS_L)
		sbci	temp2, high (MID_RC_PULS_L)
		ldi	temp4, stop
		brcc	eval_rc_p003	; if >MIN_RC_PULS then goto
		mov	temp1, new_rcpuls_l
		mov	temp2, new_rcpuls_h
		subi	temp1, low  (MID_RC_PULS_L)
		sbci	temp2, high (MID_RC_PULS_L)
		clr	temp3
		clr	temp4
		sub	temp3, temp1
		sbc	temp4, temp2
		mov	temp1, temp3
		mov	temp2, temp4
		ldi		temp4, rev
		rjmp	eval_rc_p00
eval_rc_p003:
		clr	temp1       ; else =0
		clr	temp2
eval_rc_p00:
		lds	temp3, last_dir
		sub	temp3, temp4
		breq	eval_rc_p006
		ldi	temp3, 25
		sts	reverse_count, temp3
		sts	last_dir, temp4
eval_rc_p006:
		lds	temp3, reverse_count
		tst	temp3
		breq	eval_rc_p005
		dec	temp3
		brne	eval_rc_p007
		subi	temp4, rev
		brne	eval_rc_p008
		sbr	flags2, (1<<REVERSE_FLAG)
		rjmp	eval_rc_p007
eval_rc_p008:
		cbr	flags2, (1<<REVERSE_FLAG)
eval_rc_p007:
		sts	reverse_count, temp3
		clr	temp1       ; else =0
		clr	temp2
eval_rc_p005:
		lsr	temp2       ; div 2
		ror	temp1
		lsr	temp2       ; div 2
		ror	temp1
;		lsr	temp2       ; div 2
;		ror	temp1
		mov	temp3, temp1		
		subi	temp1, low  (POWER_RANGE)
		sbci	temp2, high (POWER_RANGE)
		brcs	eval_rc_p10 ; if <100 then goto
		ldi	temp3, low  (POWER_RANGE) ; else =100
eval_rc_p10:	
.if IGNORANTEN== 1
		sbrs	flags2,STARTUP
		rjmp 	mov_zh
		;das hier sollte den motor abstellen
		;wenn der gasstick auf poweroff steht
		cpi		temp3,Min_Duty
		brlo	mov_zh
		mov		temp3,ZH
		cpi		temp3,Min_Duty
		brsh	increment	
		ldi		temp3,Min_Duty
increment:
		inc     adc_loop_counter	;Startup_count
		ldi		temp1,START_RAMP
		cp		temp1,adc_loop_counter	;Startup_count
		brlo	mov_zh
		inc 	temp3
		clr		adc_loop_counter	;Startup_count
.endif
mov_zh:
		mov		ZH, temp3
eval_rc_p90:	ret
.endif
;-----bko-----------------------------------------------------------------
evaluate_sys_state:
		sbrs	flags1, T1OVFL_FLAG
		rjmp	eval_sys_s99

	; do it not more often as every 65s
		cbr	flags1, (1<<T1OVFL_FLAG)
		
.if Current_OFF==1
		rjmp eval_sys_i_ok
.endif

	; control current
eval_sys_i:	
		sbrs	flags0, I_pFET_HIGH
		rjmp	eval_sys_i_ok
		cbr	flags0, (1<<I_pFET_HIGH)
		mov	i_temp1, current_err
		cpi	i_temp1, CURRENT_ERR_MAX
		brcc	panic_exit
		inc	current_err
		rjmp	eval_sys_ub

eval_sys_i_ok:	tst	current_err
		breq	eval_sys_ub
		dec	current_err

	; control voltage
eval_sys_ub:	
		sbrs	flags0, UB_LOW
		rjmp	eval_sys_ub_ok
		cbr	flags0, (1<<UB_LOW)
		Cbi		Accu_Port,LOWACCU
		mov	i_temp1, sys_control
		cpi	i_temp1, POWER_RANGE
		brcc	eval_sys_s99
		inc	sys_control
		rjmp	eval_sys_s99

eval_sys_ub_ok:	tst	sys_control
		breq	eval_sys_s99
		dec	sys_control
		
eval_sys_s99:	
		rcall	set_new_duty
		ret

panic_exit:	; !!!!!! OVERCURRENT !!!!!!!!

		rcall	switch_power_off
		cli
		rjmp	reset
;-----bko-----------------------------------------------------------------

wait_OCT1_before_comp_scan:
		sbr		Flags0, (1<<OCT1_PENDING)
		lds		YL, wt_comp_scan_l
		lds		YH, wt_comp_scan_h
		rcall	tcnt1_to_temp
		add		YL, temp1
		adc		YH, temp2
		ldi	temp1, (1<<TOIE1)+(1<<TOIE0)
		out	TIMSK, temp1
		out	OCR1AH, YH
		out	OCR1AL, YL
		ldi	temp1, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0) ; enable interrupt again
		out	TIMSK, temp1
		ldi	temp4, EXT0_EN		; ext0int enable
		out	GIMSK, temp4		; enable ext0int

wait_OCT1_next:	sbrc	flags0, OCT1_PENDING
		rjmp	wait_OCT1_next

wait_OCT1_tot:	
		cbi	ADCSRA, ADEN		; switch to comparator multiplexed
		in	temp1, SFIOR
		ori	temp1, (1<<ACME)
		out	SFIOR, temp1

		sbr	flags0, (1<<OCT1_PENDING)
		rcall	tcnt1_to_temp
		ldi	YL, low (compScanTIMEOUT)
		ldi	YH, high(compScanTIMEOUT)
		
		add	temp1, YL
		adc	temp2, YH
		ldi	temp3, (1<<TOIE1)+(1<<TOIE0)
		out	TIMSK, temp3
		out	OCR1AH, temp2
		out	OCR1AL, temp1
		ldi	temp3, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0)
		out	TIMSK, temp3
		ldi	temp4, EXT0_EN		; ext0int enable
		out	GIMSK, temp4		; enable ext0int

		ret
;-----bko-----------------------------------------------------------------
wait_OCT1_before_switch:
		sbr	flags0, (1<<OCT1_PENDING)
		rcall	tcnt1_to_temp
		lds	YL, wt_FET_sw_l
		lds	YH, wt_FET_sw_h
		add	temp1, YL
		adc	temp2, YH
		ldi	temp3, (1<<TOIE1)+(1<<TOIE0)
		out	TIMSK, temp3
		out	OCR1AH, temp2
		out	OCR1AL, temp1
		ldi	temp3, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0)
		out	TIMSK, temp3
		ldi	temp4, EXT0_EN		; ext0int enable
		out	GIMSK, temp4		; enable ext0int

	; don't waste time while waiting - do some controls, if indicated
OCT1_ready:	sbrc	flags1, CALC_NEXT_OCT1
		rcall	calculate_next_timing_values 	; calculate values while compare timer is active
.if RC_PULS == 1
		sbrc	flags1, EVAL_RC_PULS
		rcall	evaluate_rc_puls
.endif
		sbrc	flags1, EVAL_SYS_STATE
		rcall	evaluate_sys_state
		
		sbrc	flags0,EVAL_UB
		rcall	accu_check

		sbrc 	flags1,EVAL_I
		rcall	current_check


OCT1_wait:	sbrc	flags0, OCT1_PENDING
		rjmp	OCT1_wait
		ret
;-----bko-----------------------------------------------------------------
set_new_duty:	mov	temp1, ZH
		sub	temp1, sys_control
		brcc	set_new_duty10
		ldi	temp1, MIN_DUTY-1
set_new_duty10:	lds	temp2, OCT1_high	; get actual RPM reference high
		cpi	temp2, 8		; cpi	temp2, 8 lower than 8xx? ( 1831 RPM )
		brcs	set_new_duty20		; on carry - test next range
		ldi	temp2, MAX_POWER_RPM1	; higher than power max range1 ?
		cp	temp1, temp2
		brcs	set_new_duty30		; on carry - not higher, no restriction
		mov	temp1, temp2		; low (range1) RPM - set to 1/4 max
		rjmp	set_new_duty30
set_new_duty20:	cpi	temp2, 4		; lower than 4xx? ( 3662 RPM )
		brcs	set_new_duty30		; on carry - not lower, no restriction
		ldi	temp2, MAX_POWER_RPM2	; higher than power max range2 ?
		cp	temp1, temp2
		brcs	set_new_duty30		; on carry - not higher, no restriction
		mov	temp1, temp2		; low (range2) RPM - set to 1/2 max
set_new_duty30:	com	temp1			; down-count to up-count (T0)
		mov	tcnt0_pwron_next, temp1	; save in next
	; tcnt0_power_on is updated to tcnt0_pwron_next in acceptable steps
		ret
;-----bko-----------------------------------------------------------------
set_default_timeout:
		ldi	temp1, NO_POWER
		mov	tcnt0_power_on, temp1
		ldi	temp1, 8
		sts	OCT1_high, temp1
		ldi	YL, low (defaultTIMEOUT)
		ldi	YH, high(defaultTIMEOUT)
		sts	wt_comp_scan_l, YL	; write default timing value
		sts	wt_comp_scan_h, YH
		ret
;-----bko-----------------------------------------------------------------
.if UART_CONTROL == 1
read_uart:	in	temp1,UDR	; read data - clear rxc-flag
		cpi	temp1,'+'
		brne	read_uart_10
	; do (+) job
		cpi	ZH, POWER_RANGE
		brsh	read_uart_90
		rcall	send_byte
		inc	ZH
		rcall	set_new_duty
		rjmp	read_uart_90
read_uart_10:	cpi	temp1,'-'
		brne	read_uart_20
	; do (-) job
		cpi	ZH, MIN_DUTY-1
		breq	read_uart_90
		rcall	send_byte
		dec	ZH
		rcall	set_new_duty
		rjmp	read_uart_90
read_uart_20:
.if UART_FULL == 1
		cpi	temp1,'#'
		brne	read_uart_30
	; do (#) job
		clr	XH
		ldi	XL, uart_data
		sbr	flags0, (1<<GET_STATE)
		ldi	temp1,0x0d
		rcall	send_byte
		ldi	temp1,'#'
		st	X+,temp1
		mov	temp1,flags0
		rcall	hex2buf
		mov	temp1,flags1
		rcall	hex2buf
		mov	temp1,tcnt0_power_on
		rcall	hex2buf
		lds	temp1,wt_comp_scan_h
		rcall	hex2buf
		lds	temp1,wt_comp_scan_l
		rcall	hex2buf
		ldi	temp1,'-'
		st	X+,temp1
		rjmp	read_uart_90
.endif
read_uart_30:	cpi	temp1,'1'
		brne	read_uart_40
	; do (1) job
		ldi	ZH, MIN_DUTY+0x30
		rcall	send_byte
		rcall	set_new_duty
		rjmp	read_uart_90
read_uart_40:	cpi	temp1,'2'
		brne	read_uart_89
	; do (2) job
		ldi	ZH, MIN_DUTY-1
		rcall	send_byte
		rcall	set_new_duty
		rjmp	read_uart_90
read_uart_89:	ldi	temp1,'?'
		rcall	send_byte
read_uart_90:	ret

;-----bko-----------------------------------------------------------------
hex_out:	mov	temp2,temp1
		swap	temp1
		rcall	nibble_out
		mov	temp1,temp2
		rcall	nibble_out
		ret
	
nibble_out:	andi	temp1,0x0f
		ori	temp1,0x30
		cpi	temp1,0x3a
		brlo	nibble_out_10
		subi	temp1,-7
nibble_out_10:
send_byte:	sbi	USR,TXC		; clear flag
		out	UDR,temp1
nibble_out_20:	sbis	USR,TXC
		rjmp	nibble_out_20
		ret
;-----bko-----------------------------------------------------------------
  .if UART_FULL == 1
hex2buf:	mov	temp2,temp1
		swap	temp1
		rcall	nibble2buf
		mov	temp1,temp2
		rcall	nibble2buf
		ret
	
nibble2buf:	andi	temp1,0x0f
		ori	temp1,0x30
		cpi	temp1,0x3a
		brlo	nibble2buf_10
		subi	temp1,-7
nibble2buf_10:	st	X+,temp1
		ret
;-----bko-----------------------------------------------------------------
save_state:	mov	temp1,flags0
		rcall	hex2buf
		mov	temp1, current_err
		rcall	hex2buf
		mov	temp1, sys_control
		rcall	hex2buf
		ldi	temp1,'-'
		st	X+,temp1
		ret		
;-----bko-----------------------------------------------------------------
send_state:	ldi	temp1,0x0d
		st	X+,temp1
		ldi	temp1,0x0a
		st	X+,temp1
		subi	XL,uart_data
		mov	uart_cnt,XL
		ldi	XL,uart_data
		sbi	USR, TXC		; clear flag
		sbi	UCR, TXCIE		; enable irq
		ldi	temp1,0x0a		; start transmission
		out	UDR,temp1
		cbr	flags0, (1<<GET_STATE)
		ret		
;-----bko-----------------------------------------------------------------
utxc:		ld	i_temp1,X+
		out	UDR, i_temp1
		dec	uart_cnt
		brne	utxc_90
		cbi	UCR, TXCIE		; disable irq
utxc_90:	reti

  .endif		; UART_FULL == 1
.endif		; UART_CONTROL == 1

;-----bko-----------------------------------------------------------------
switch_power_off:
		ldi	temp1, NO_POWER		; lowest tcnt0_power_on value
		mov	tcnt0_pwron_next, temp1	; set lowest
		ldi	temp1, INIT_PB		; all off
		;hier wirds kompliziert wirklich?
		;Die nfets liegen alle auf dem gleichen port
		;also alle gemeinsam abschalten
        in  temp1,AnFET_PORT
		cbr temp1,(1<<AnFET)+(1<<BnFET)+(1<<CnFET)
		out	AnFET_PORT, temp1
		
		;Die pfets nacheinader abschalten
		in	temp1,ApFET_PORT
		cbr temp1,(1<<ApFET)
		out	ApFET_PORT,temp1

		in	temp1,BpFET_PORT
		cbr temp1,(1<<BpFET)
		out	BpFET_PORT,temp1
		
		in	temp1,CpFET_PORT
		cbr temp1,(1<<CpFET)
		out	CpFET_PORT,temp1
        ;ok alles aus

		ldi	temp1, CHANGE_TIMEOUT	; reset change-timeout
		mov	tcnt0_change_tot, temp1
		sbr	flags1, (1<<POWER_OFF)	; disable power on
		cbr	flags2, (1<<POFF_CYCLE)
		cbr	flags1, (1<<FULL_POWER)
		ret				; motor is off
;-----bko-----------------------------------------------------------------
wait_if_spike:	ldi	temp1, 4
wait_if_spike2:	dec	temp1
		brne	wait_if_spike2
		ret


;-----bko-----------------------------------------------------------------
motor_brake:
.if MOT_BRAKE == 1
		sbrc 	flags2, BRAKE_DONE
		rjmp	mot_brk90
		ldi	temp2, 80		; 40 * 0.065ms = 2.6 sec
		ldi	temp1, BRAKE_PB		; all N-FETs on
		out		BRAKE_PORT, temp1
mot_brk10:	
		sbrs	flags1, T1OVFL_FLAG
		rjmp	mot_brk10
		cbr	flags1, (1<<T1OVFL_FLAG)
.if RC_PULS == 1
		push	temp2
		rcall	evaluate_rc_puls
		pop		temp2
		cpi		ZH, MIN_DUTY+3		; avoid jitter detect
		brcs	mot_brk20
		rjmp	mot_brk90
mot_brk20:
.endif
		dec		temp2
		brne	mot_brk10
		sbr	flags2, (1<<BRAKE_DONE)
.if RC_PULS == 1
mot_brk90:
.endif
		ldi	temp1, INIT_PB		; all off
		out	BRAKE_PORT, temp1
.endif	; MOT_BRAKE == 1
		rcall	wait260ms
		ret


;-----bko-----------------------------------------------------------------
; **** start closed control loop ****

; state 1 = B(p-on) + C(n-choppered) - comparator A evaluated
; out_cA changes from low to high

state1:		
		sbrc	flags0, OCT1_PENDING
		rjmp	state1_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rjmp	s1_close
state1_2:	
		sbic	ACSR, ACO		; high ?
		rjmp	state1			; .. no - loop, while low
		rcall	wait_if_spike		; .. yes - look for a spike
		sbic	ACSR, ACO		; test again
		rjmp	state1			; .. is low again, was a spike
		
		rcall	wait_OCT1_before_switch
s1_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		sbrc	flags2, REVERSE_FLAG
		cbi	BpFET_PORT, BpFET		; Bp off
		sbrs	flags2, REVERSE_FLAG
		cbi	ApFET_PORT, ApFET		; Bp off
		nop				; neccessary for pullup
		nop
		sbrc	flags1, POWER_OFF
rjmp s1_close2
		sbrc	flags2, REVERSE_FLAG
		sbi		ApFET_PORT, ApFET		; Ap on
		sbrs	flags2, REVERSE_FLAG
		sbi		BpFET_PORT, BpFET		; Ap on
s1_close2:
		sbrc	flags2, REVERSE_FLAG
		ldi		temp1, mux_b		; set comparator multiplexer to phase B
		sbrs	flags2, REVERSE_FLAG
		ldi		temp1, mux_a		; set comparator multiplexer to phase B
		out		ADMUX, temp1

		rcall	wait_OCT1_before_comp_scan

	

; state 2 = A(p-on) + C(n-choppered) - comparator B evaluated
; out_cB changes from high to low

state2:	
		sbrc	flags0, OCT1_PENDING
		rjmp	state2_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rjmp	s2_close		
state2_2:	
		sbis	ACSR, ACO		; low ?
		rjmp	state2			; .. no
		rcall	wait_if_spike
		sbis	ACSR, ACO
		rjmp	state2			; high again
		
		sbr	flags1, (1<<EVAL_RC_PULS)
		rcall	wait_OCT1_before_switch
		cbr	flags1, (1<<EVAL_RC_PULS)
		
		
s2_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		ldi	temp1, (1<<OCIE1A)+(1<<TOIE1) ; stop timer0 interrupt
		out	TIMSK, temp1		;  .. only ONE should change these values at the time
		cbr	flags0, (1<<A_FET)	; next nFET = BnFET
		cbr	flags0, (1<<C_FET)
		sbrc	flags1, FULL_POWER
		rjmp	s2_switch
		sbrc	flags0, I_OFF_CYCLE	; was power off ?
		rjmp	s2_done			; .. yes - futhermore work is done in timer0 interrupt
s2_switch:	
		cbi	CnFET_PORT, CnFET		; Cn off
		sbrc	flags1, POWER_OFF
		rjmp	s2_done
		sbrc	flags2, REVERSE_FLAG
		sbi	BnFET_PORT, BnFET		; Bn on
		sbrs	flags2, REVERSE_FLAG
		sbi	AnFET_PORT, AnFET		; Bn on
s2_done:	
		ldi	temp1, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0) ; let timer0 do his work again
		out	TIMSK, temp1
		ldi	temp1, mux_c		; set comparator multiplexer to phase C
		out	ADMUX, temp1
		rcall	wait_OCT1_before_comp_scan

; state 3 = A(p-on) + B(n-choppered) - comparator C evaluated


state3:		
 		sbrc	flags0, OCT1_PENDING
		rjmp	state3_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rjmp	s3_close
state3_2:	
		sbic	ACSR, ACO
		rjmp	state3
		rcall	wait_if_spike
		sbic	ACSR, ACO
		rjmp	state3

		sbr		flags0, (1<<EVAL_UB) ; Voltage evaluation request start
		rcall	wait_OCT1_before_switch
		cbr		flags0, (1<<EVAL_UB) ; Voltage evaluation request stop
s3_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		sbrc	flags2, REVERSE_FLAG
		cbi	ApFET_PORT, ApFET		; Ap off
		sbrs	flags2, REVERSE_FLAG
		cbi	BpFET_PORT, BpFET		; Ap off
		nop				; neccessary for pullup
		nop
		sbrs	flags1, POWER_OFF
		sbi	CpFET_PORT, CpFET		; Cp on

.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	send_state
  .endif
	; not very much to do - look for UART input
		sbic	USR,RXC
		rcall	read_uart
.endif
		sbrc	flags2, REVERSE_FLAG
		ldi	temp1, mux_a		; set comparator multiplexer to phase A
		sbrs	flags2, REVERSE_FLAG
		ldi	temp1, mux_b		; set comparator multiplexer to phase A
		out	ADMUX, temp1
		rcall	wait_OCT1_before_comp_scan

; state 4 = C(p-on) + B(n-choppered) - comparator A evaluated
; out_cA changes from high to low
state4:	
		sbrc	flags0, OCT1_PENDING
		rjmp	state4_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rjmp	s4_close
state4_2:	
		sbis	ACSR, ACO
		rjmp	state4
		rcall	wait_if_spike
		sbis	ACSR, ACO
		rjmp	state4

		sbr		flags1, (1<<EVAL_I) ; current evaluation request stop
		rcall	wait_OCT1_before_switch
		cbr		flags1, (1<<EVAL_I) ; current evaluation request stop
s4_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		ldi	temp1, (1<<OCIE1A)+(1<<TOIE1) ; stop timer0 interrupt
		out	TIMSK, temp1		;  .. only ONE should change these values at the time
		sbr	flags0, (1<<A_FET)	; next nFET = AnFET
		cbr	flags0, (1<<C_FET)
		sbrc	flags1, FULL_POWER
		rjmp	s4_switch
		sbrc	flags0, I_OFF_CYCLE	; was power off ?
		rjmp	s4_done			; .. yes - futhermore work is done in timer0 interrupt
s4_switch:	
		sbrc	flags2, REVERSE_FLAG
		cbi	BnFET_PORT, BnFET		; Bn off
		sbrs	flags2, REVERSE_FLAG
		cbi	AnFET_PORT, AnFET		; Bn off
		sbrc	flags1, POWER_OFF
		rjmp	s4_done
		sbrc	flags2, REVERSE_FLAG
		sbi	AnFET_PORT, AnFET		; An on
		sbrs	flags2, REVERSE_FLAG
		sbi	BnFET_PORT, BnFET		; An on
s4_done:	ldi	temp1, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0) ; let timer0 do his work again
		out	TIMSK, temp1
		sbrc	flags2, REVERSE_FLAG
		ldi	temp1, mux_b		; set comparator multiplexer to phase B
		sbrs	flags2, REVERSE_FLAG
		ldi	temp1, mux_a		; set comparator multiplexer to phase B
		out	ADMUX, temp1
		
		cbr	flags2, (1<<POFF_CYCLE)
		mov	temp1, run_control
		cpi	temp1, 1
		breq	s4_continue
		dec	run_control
		mov	temp1, run_control
		cpi	temp1, 4
		breq	s4_poff_cycle
		cpi	temp1, 3
		breq	s4_poff_cycle
		cpi	temp1, 2
		breq	s4_poff_cycle
		rjmp	s4_continue
s4_poff_cycle:	sbr	flags2, (1<<POFF_CYCLE)
s4_continue:	
		rcall	wait_OCT1_before_comp_scan

; state 5 = C(p-on) + A(n-choppered) - comparator B evaluated
; out_cB changes from low to high

state5:	
		sbrc	flags0, OCT1_PENDING
		rjmp	state5_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rcall	evaluate_sys_state
		rjmp	s5_close
state5_2:	
		sbic	ACSR, ACO
		rjmp	state5
		rcall	wait_if_spike
		sbic	ACSR, ACO
		rjmp	state5
		
		sbr	flags1, (1<<EVAL_SYS_STATE)
		rcall	wait_OCT1_before_switch
		cbr	flags1, (1<<EVAL_SYS_STATE)
s5_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		cbi		CpFET_PORT, CpFET		; Cp off
		nop				; neccessary for pullup
		nop
		sbrc	flags1, POWER_OFF
		rjmp	s5_close2
		sbrc	flags2, REVERSE_FLAG
		sbi		BpFET_PORT, BpFET		; Bp on
		sbrs	flags2, REVERSE_FLAG
		sbi		ApFET_PORT, ApFET		; Bp on
s5_close2:		
		ldi		temp1, mux_c		; set comparator multiplexer to phase C
		out		ADMUX, temp1
		rcall	wait_OCT1_before_comp_scan

; state 6 = B(p-on) + A(n-choppered) - comparator C evaluated
; out_cC changes from high to low

state6:	
		sbrc	flags0, OCT1_PENDING
		rjmp	state6_2
.if RC_PULS == 1
		rcall	update_power_control
.endif
		rcall	calculate_next_timing_values
		rjmp	s6_close
state6_2:	
		sbis	ACSR, ACO
		rjmp	state6
		rcall	wait_if_spike
		sbis	ACSR, ACO
		rjmp	state6
		
		sbr	flags1, (1<<CALC_NEXT_OCT1)
		rcall	wait_OCT1_before_switch
		cbr	flags1, (1<<CALC_NEXT_OCT1)
s6_close:
.if UART_CONTROL == 1
  .if UART_FULL == 1
		sbrc	flags0, GET_STATE
		rcall	save_state
  .endif
.endif
		ldi	temp1, (1<<OCIE1A)+(1<<TOIE1) ; stop timer0 interrupt
		out	TIMSK, temp1		;  .. only ONE should change these values at the time
		cbr	flags0, (1<<A_FET)	; next nFET = CnFET
		sbr	flags0, (1<<C_FET)
		sbrc	flags1, FULL_POWER
		rjmp	s6_switch
		sbrc	flags0, I_OFF_CYCLE	; was power off ?
		rjmp	s6_done			; .. yes - futhermore work is done in timer0 interrupt
s6_switch:	
		sbrc	flags2, REVERSE_FLAG
		cbi	AnFET_PORT, AnFET		; An off
		sbrs	flags2, REVERSE_FLAG
		cbi	BnFET_PORT, BnFET		; An off
		sbrs	flags1, POWER_OFF
		sbi	CnFET_PORT, CnFET		; Cn on
s6_done:ldi	temp1, (1<<TOIE1)+(1<<OCIE1A)+(1<<TOIE0) ; let timer0 do his work again
		out	TIMSK, temp1
		sbrc	flags2, REVERSE_FLAG
		ldi	temp1, mux_a		; set comparator multiplexer to phase A
		sbrs	flags2, REVERSE_FLAG
		ldi	temp1, mux_b		; set comparator multiplexer to phase A
		out	ADMUX, temp1

		rcall	wait_OCT1_before_comp_scan ; use newly calculated values

		tst		rcpuls_timeout
		breq	restart_control
		
		; Attention Double used POWER_OFF flag
		sbrc	flags2, POFF_CYCLE    ; don't brake in a POFF_CYCLE
        rjmp	No_brake_tst

		sbrc	flags1, POWER_OFF
		rcall	motor_brake
		sbrs	flags1, POWER_OFF
		cbr		flags2, (1<<BRAKE_DONE)

No_brake_tst:
		
.if IGNORANTEN== 1
		cbr		flags2,1<<STARTUP
		tst		run_control
		breq 	go_state1
		sbr		flags2,1<<STARTUP
else
		cbr		flags2,1<<STARTUP
.endif

go_state1:
		rjmp	state1			; go back to state 1

restart_control:
		cli				; disable all interrupts
		rjmp	reset

;*********************************************************************
;* Funktion: CURRENT_CHECK                                              *
;*********************************************************************
CURRENT_CHECK:
.if Current_OFF	== 1
	ret
.endif
	sbrs	flags1,EVAL_I	; take a look if measurementr schould be started
	ret
	;******************************************
	; es muss strom Fliessen damits sinn macht
	; spielt keine rolle welche Phase aber
	; no OFF cycle
	;******************************************
	;bzw welche comparator mux war hier eingeschaltet
	in		temp1,ADMUX
	sts 	ComparatorMUX,temp1
	; hier den richtigen  "pfad" angeben INC file
	; set comparator multiplexer to ADC Multiplexer
	; ACCU Voltage Input
	ldi		temp1, CURRENT_MUX	
	out		ADMUX, temp1

	; ACME (SFIOR) muss 0 sein to activate ADC multiplexer
	; SFIOR Special Function IO Register
	in		temp1, SFIOR
	cbr		temp1, (1<<ACME)
	out		SFIOR, temp1
	sbi		ADCSRA,ADEN 	
	nop
	nop
	; wieviel wartezeit ist hier ntig
	; bis der s&h c Voll ist
	sbi		ADCSRA,ADSC ; start the conversion
ADCC_IS_STARTED_2:
	sbic	ADCSR,ADSC
	rjmp	ADCC_IS_STARTED_2 ; wait until measured
	cbr		flags1,1<<EVAL_I		;clear flag measurement done

	in		temp1,ADCL ; we read the ADC-value both ADC regs MUST be read
	in		temp2,ADCH ; we have also to read ADCH to get the measured value

	;was ham wer denn frn widerstand
	;0.01 Ohm --> 1A 0.01V / 10A 0.1V / 20A 0.2V / 40A 0.4V
    ; adc setting  5V mit 10 bit
	;5/1024 4,88mV/bit --> ergibt 0.5 A/bit Hier stellt sich die frage
	; 1A 0.01V = 2 / 10A 0.1V = 20  / 20A 0.2V = 40 / 40A 0.4V = 81
	; umschalten auf 2.5 Volt ref ?
	; 2,5/1024 2,44mV/bit --> ergibt 0.25 A/bit
	;lowbyte Reicht zum testen  value klein genug
	;cpi		temp1,overcurrent_20	
	;ldi		temp2,overcurrent_40
	cpi		temp1,overcurrent_40
	brlo	Current_OK
	sbr		flags0,1<<I_pFET_HIGH
	;error counter necessary? nein erledigt syscontrol

Current_OK:
    lds 	temp3,ComparatorMUX
	out		ADMUX,temp3

	cbi		ADCSRA,ADEN 	; disable ad

	in		temp3, SFIOR
	sbr		temp3, (1<<ACME)
	out		SFIOR, temp3	; switch to  comparator

ret

;*********************************************************************
;* Funktion: ACCU_CHECK                                              *
;*********************************************************************
;* Description: accu-check                                           *
; ist viel viel viel zu langsam so
; change to 2 byte calculation
;* Wy not use a free running adc	because the mux must be switched *
;*       ; adc 100KHz 15cyc-->150yS	att 1.6MHz --> 240cyc        *
;*       ; adc 200KHz 15cyc--> 75yS	att 1.6MHz --> 120cyc	     *
;* changeed -->start adc directly after leaving function             *
;*********************************************************************

ACCU_CHECK:
.if Accucheck_OFF	== 1
	ret
.endif
	sbrs	flags0,EVAL_UB	; take a look if measurementr schould be started
	ret
	;bzw welche comparator mux war hier eingeschaltet
	in		temp1,ADMUX
	sts 	ComparatorMUX,temp1
	
	; hier den richtigen  "pfad" angeben INC file
	; set comparator multiplexer to ADC Multiplexer
	; ACCU Voltage Input
	ldi		temp1, ACCU_MUX	
	out		ADMUX, temp1

	; ACME (SFIOR) muss 0 sein to activate ADC multiplexer
	; SFIOR Special Function IO Register
	in		temp1, SFIOR
	cbr		temp1, (1<<ACME)
	out		SFIOR, temp1
	sbi		ADCSRA,ADEN 	
	nop
	nop
	; wieviel wartezeit ist hier ntig
	; bis der s&h c Voll ist
	sbi		ADCSRA,ADSC ; start the conversion
ADC_IS_STARTED_2:
	sbic	ADCSRA,ADSC
	rjmp	ADC_IS_STARTED_2 ; wait until measured
	in		temp1,ADCL ; we read the ADC-value both ADC regs MUST be read
	in		temp2,ADCH ; we have also to read ADCH to get the measured value
	cbr		flags0,1<<EVAL_UB		;clear flag measurement done
	;und wieder auf comparator mux umschalten
	; ACME (SFIOR) muss 0 sein to activate ADC multiplexer
	; ACME (SFIOR) muss 1 sein to activate comparator multiplexer
	; SFIOR Special Function IO Register
	lds 	temp3,ComparatorMUX
	out		ADMUX,temp3
	cbi		ADCSRA,ADEN 	; disable ad
	in		temp3, SFIOR
	sbr		temp3, (1<<ACME)
	out		SFIOR, temp3	; switch to  comparator

.IFDEF DEBUG
	;68K / 12K  32.0V Vin(~22 zellen)->>  4.8V at ADC in
	;           10.2V Vin (7 zellen Voll)
	;10.2V Ubatt --> 1,53V ADC IN 1,53/(5/1024) 1,53/27mV  375 digits 139hex
	;10.2V Ubatt -->7 zellen 6.3V slowdown 5.6V switch off
	;ldi temp1,0x75 ;low
	;ldi temp2,0x01 ;high
	ldi temp1,0xda ;218 7,1V
	ldi temp1,0xb0 ;218 6, V

.ENDIF

    lds		temp3, slow_down_voltage_l
	lds		temp4, slow_down_voltage_h
	
	sub		temp3,temp1
	sbc		temp4,temp2
	brcs 	LEAVE_ADC_1
		
    sbr		flags0,(1 << UB_LOW)
	sbi		Accu_Port,LOWACCU
	cbr		flags1,(1<<FULL_POWER);do not allow Full power

	
	ldi		temp3, low(MIN_ACCU)
	ldi		temp4, HIGH(MIN_ACCU)
	
	sbrs 	flags2,Lithium_Accu
	rjmp 	go_check

	;wenn wir low accu erreicht haben auch auf switch off testen
	lds		temp3, Switch_off_voltage_l ;MIN accu @ NC
	lds		temp4, Switch_off_voltage_h ; 2.XV/z @LIPO

go_check:	
	sub		temp3,temp1
	sbc		temp4,temp2
	brcs 	LEAVE_ADC_1

.if Switch_off_activ==1
	;switch off motor
	rcall	switch_power_off;
	cli
	rjmp reset
.else
	inc	sys_control ;Additional motor Powerdown
	inc	sys_control
.endif
	;clr 	sys_control

LEAVE_ADC_1:
	ret	

;*********************************************************************
;* Funktion: EEpromRead                                              *
;*********************************************************************
;* Description: This funktion Reads data from eeprom                 *
;*              in  -->temp1 low  ram dadress to read                *
;*              in  -->temp2 high ram dadress to read                *
;*              out -->temp1 readed value                            *
;*********************************************************************
EEpromRead:	
		wdr ;
		cli			; int disable
		out	EEARH,temp2		
		out	EEARL,temp1		; TMPlow  enthlt eeprom addr
		sbi	EECR,EERE	    ; Start eprom read
EEpromR_A:	
		sbic	EECR, EERE	; read complete ?
		rjmp	EEpromR_A	;
		in	temp1, EEDR		; read data register
		sei			; int enable
		ret			;

;*********************************************************************
;* Funktion: EEpromWrite                                             *
;*********************************************************************
;* Description: This funktion Reads data from eeprom                 *
;*              in  -->temp1 low  ram adress to write to             *
;*              in  -->temp2 high ram adress to write to             *
;*              out -->temp3 Value to write                          *
;*********************************************************************
EEpromWrite:
		wdr ;
		cli			; int disable
		sbic EECR,EEWE    ; write enable ????
		rjmp EEpromWrite
		
		out	EEARL, temp1	; eeprom addr
		out	EEARH, temp2	; eeprom addr
		out	EEDR, temp3		; load dataregister
		sbi	EECR, EEMWE	    ; activatet eeprom write by writing EEMWE
		sbi	EECR, EEWE	    ; Start eeprom write by writing EEWE
		sei			; int enable
		ret			;


.exit





